<?php

namespace Daite\Coopdigital\Http\Middleware;

use Closure;
use Illuminate\Http\Request;

class VerificacionInicioSesion
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure(\Illuminate\Http\Request): (\Illuminate\Http\Response|\Illuminate\Http\RedirectResponse)  $next
     * @return \Illuminate\Http\Response|\Illuminate\Http\RedirectResponse
     */
    public function handle(Request $request, Closure $next)
    {
        if ($request->is('api/*')) {
            return $next($request);
        }

        if (!session() -> has('usuarioIniciado') && ($request -> path() != '/' && $request -> path() != '/iniciarSesion')) {

            return redirect('/') -> with('fail', '¡Tienes que iniciar sesión para poder acceder al panel!');

        } else if (session() -> has('usuarioIniciado') && ($request -> path() == '/' || $request -> path() == '/iniciarSesion')) {

            return redirect()->route('panel.inicio');

        }

        return $next($request) 
        -> header('Cache-Control', 'no-cache, no-store, max-age=0, must-revalidate')
        -> header('Pragma', 'no-cache')
        -> header('Expires', 'Sat 01 Jan 1990 00:00:00 GMT')
        ;
    }
}
